package main

import (
	"fmt"
	"io"
	"log"
	"os"
	"time"
)

// ExampleFile
func main() {
	// 使用 go run 时，当前路径是程序的运行路径
	//path := "/etc/hosts.bak"
	path := "a.txt"

	// 打开文件
	file, err := os.Open(path)
	// 结束时关闭文件
	defer file.Close()
	if err != nil {
		// 1. open /etc/hosts.bak: no such file or directory
		// 2. file not prem
		fmt.Println(err.Error())
		//return
	} else {
		// 读文件
		fmt.Printf("%T\n", file)
		var bs []byte = make([]byte, 10) // [0 0 0 0 0 0 0 0 0 0]
		for {
			n, err := file.Read(bs)
			if err == io.EOF || err != nil {
				if err == io.EOF {
					fmt.Println(err.Error())
				}
				break
			}
			fmt.Print(string(bs[:n]))
		}
	}

	// 写文件
	file, err = os.Create(path)
	if err != nil {
		fmt.Println(err.Error())
		return
	}
	defer file.Close()
	// 每次 write 都执行 truncate 操作
	//n, err := file.Write([]byte("hello file"))
	n, err := file.WriteString("hello file2")
	if err != nil {
		return
	}
	if err != nil {
		fmt.Println(err.Error())
		return
	} else {
		fmt.Println("write bytes", n)
	}

	// 文件追加写
	//file, err = os.OpenFile(path, os.O_APPEND|os.O_APPEND|os.O_WRONLY, os.ModeAppend)
	file, err = os.OpenFile(path, os.O_APPEND|os.O_APPEND|os.O_WRONLY, os.ModePerm)

	if err != nil {
		fmt.Println(err.Error())
		return
	}
	defer file.Close()
	file.WriteString("\n")
	t := time.Now().Format("2006/01/02 15:04:05")
	fmt.Println(t)
	n, err = file.WriteString(t)
	if err != nil {
		fmt.Println(err.Error())
		return
	}
	fmt.Println("append write", n)
	file.WriteString("\n")

	// 通过 log 模块写
	log.SetOutput(file)
	log.SetPrefix("main:")
	log.SetFlags(log.Flags() | log.Llongfile)
	log.Println(t)
	log.Println("write from log modules")
}
